#ifndef stack_h

#define stack_h
#include <stdio.h>
#include <stdlib.h>

struct stack {
	       int num_val;
	       struct nodo *link_pila;
	      };


struct nodo {
	      void* info;
	      struct nodo *next;
	    };

typedef struct stack stack_label;
typedef struct nodo nodo_label;

stack_label *create_stack(stack_label *new_stack);
void push(stack_label *new_stack, void* val);
void* pop(stack_label *new_stack);
void* top(const stack_label *new_stack);
int isempty(const stack_label *new_stack);
void free_stack(stack_label *new_stack);

#endif
