#include "queue.h"
#include "stack.h"

#define DIM 10

void check(int scelta);

int main()
{
    int vet[]={1,2,3,4,5,6,7,8,9,10};
    int i;
    int scelta=0;
    void* app;
    queue_label *queue, *qtmp;
    stack_label *stack;
    

    queue=create_queue(queue);
    qtmp=create_queue(qtmp);
    stack=create_stack(stack);

    for(i=0;i<10;i++) enqueue(queue,(void*)vet[i]);

    check(scelta=isempty_q(queue));
  
    
    printf("\n--------------------- Fase di stampa della Coda -------------------------\n\n");
    
    printf("\nElemento di front:%d\n\n",(int)front(queue));
    qtmp->testa=queue->testa;

    while(!isempty_q(qtmp))
    {
        printf("%3d",(int)qtmp->testa->info);
        qtmp->testa=qtmp->testa->next;
    }	
    
    while(!isempty_q(queue))
    {
        push(stack,dequeue(queue)); 
    }
    
    printf("\n--------------------- Fase di stampa della Pila -------------------------\n\n");
    
    printf("\n\nNumero elementi nella pila:%d\n\n",stack->num_val);

     while(!isempty(stack))
    {
	    app=pop(stack);
	    printf("%3d",(int)app);
    }

    check(scelta=isempty_q(queue));
    
    printf("\n\n");
    return 0;
}

void check(int scelta)
{
  switch(scelta)
  {
     case 1: printf("\n\nCoda Vuota!\n");
             break;

     case 0: printf("\n\nCoda Piena!\n");
             break;
  }
}
