#include "queue.h"

nodo_labelq *create_nodoq(nodo_labelq *new_nodo, void* elem);


nodo_labelq *create_nodoq(nodo_labelq *new_nodo, void* elem)
{
	new_nodo=(nodo_labelq*)malloc(sizeof(nodo_labelq));
        if(!new_nodo) exit(1); /*check memory allocation*/
	new_nodo->next=NULL;
	new_nodo->info=elem;
	return new_nodo;
}
	
queue_label *create_queue(queue_label *new_queue)
{
	new_queue=(queue_label*)malloc(sizeof(queue_label));
	if(!new_queue) exit(1); /*check memory allocation*/
	new_queue->num_val=0;
	new_queue->testa=NULL;
	new_queue->coda=NULL;
	return new_queue;
}

void enqueue(queue_label *new_queue, void* elem)  /*l'inserimento avviene in coda */
{
	nodo_labelq *tmp;
	
	tmp=create_nodoq(tmp,elem);  /*creazione nodo*/
	
	if(isempty_q(new_queue)) {
		                  new_queue->testa=tmp;
		                  new_queue->coda=tmp;
		                }
	else {
		new_queue->coda->next=tmp;
		new_queue->coda=tmp;
             }
	new_queue->num_val++;
}

void* dequeue(queue_label *new_queue)   /*la cancellazione avviene in testa */
{
    nodo_labelq *tmp;
    void* elem;

    tmp=new_queue->testa;
    elem=tmp->info;

    new_queue->testa=tmp->next;
    new_queue->num_val--;
    
    free(tmp);
    return elem;
}

void* front(const queue_label *new_queue)
{
	return (new_queue->testa->info); /* ritorno l'elemento in testa */
}

int isempty_q(const queue_label *new_queue)
{
	if(!new_queue->testa) return 1;
	else return 0;
}
